/*
 * HTTollBar.java
 *
 * The MIT License :
 * -----------------
 * Copyright (c) 2005 Embrapa Informtica Agropecuria
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

import java.awt.*;
import javax.swing.*;
import java.net.URL ;

public class HTToolBar extends JToolBar {
  public HTToolBar(HTView view) { 
    String[] imageFiles =
      { "gravar1.gif", "xml1.gif", "separator", "inserir1.gif",
        "editar1.gif", "copiar1.gif", "colar1.gif", "colarE.gif", "undo1.gif","separator", "remover1.gif", "separator", "center1.gif" };
    String[] toolbarLabels =
      { "Gravar rvore", "Gravar formato XML", "separator", "Inserir", "Editar", "Copiar", "Colar", "Colar Arco Escondido",
        "Recuperar", "separator","Remover", "separator", "Centralizar a rvore"};
    Insets margins = new Insets(0, 0, 0, 0);
    for(int i=0; i<toolbarLabels.length; i++) {
        //ToolBarButton button =
        //new ToolBarButton("images/" + imageFiles[i]);

	   if (!(imageFiles[i].toLowerCase().equals("separator"))) {
         	URL imageURL = getClass().getResource("images/" + imageFiles[i]);
	   	ToolBarButton button = new ToolBarButton(imageURL);
         	button.setToolTipText(toolbarLabels[i]);
         	button.setMargin(margins);
         	add(button);
		button.addActionListener(view.getAction()); 	
		view.setButtonGeneric(toolbarLabels[i], button);
	   } else
		addSeparator();
    }
  }

  public void separator() {

	addSeparator();
  }

  public void setTextLabels(boolean labelsAreEnabled) {
    Component c;
    int i = 0;
    while((c = getComponentAtIndex(i++)) != null) {
      ToolBarButton button = (ToolBarButton)c;
      if (labelsAreEnabled)
        button.setText(button.getToolTipText());
      else
        button.setText(null);
    }
  }
/*
  public boolean isOptimizedDrawingEnabled() {
	return false;
  }
*/

}
