/*
 * HTColorPicker.java
 *
 * The MIT License :
 * -----------------
 * Copyright (c) 2005 Embrapa Informtica Agropecuria
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class HTColorPicker extends Frame implements ActionListener, AdjustmentListener {
	Frame outerBox;
	Panel colorBox;
	boolean OK = false;
	boolean bExit = false;
	TextField result;

	Scrollbar redSlider, greenSlider, blueSlider;

	TextField redText, greenText, blueText;

	TextField redHex, greenHex, blueHex;
	Button BO, BC;

	GridBagLayout gbLayout;
	GridBagConstraints gbConstraints;

	//Dialog myColor;

	int redValue   = 255;
	int greenValue = 255;
	int blueValue  = 255;

	public HTColorPicker(TextField t) {
		result = t;
		bExit = false;
		buildWindow();
	}

      protected Button makebutton(String name, GridBagLayout gridbag, GridBagConstraints c, Frame viewFrame) 
      { 
	 	Button button = new Button(name); 
	 	gridbag.setConstraints(button, c); 
	      viewFrame.add(button);		
		return button;
      } 

	private void buildWindow() {
		outerBox = new Frame();
		colorBox = new Panel();

		outerBox.setBackground(new Color(redValue, greenValue, blueValue));
		colorBox.setBackground(new Color(redValue, greenValue, blueValue));

		redSlider = new Scrollbar(Scrollbar.HORIZONTAL, redValue, 1, 0, redValue + 1);
		redSlider.setBackground(new Color(redValue, 0, 0));
		redSlider.addAdjustmentListener(this);
		greenSlider = new Scrollbar(Scrollbar.HORIZONTAL, greenValue, 1, 0, greenValue + 1);
		greenSlider.setBackground(new Color(0, greenValue, 0));
		greenSlider.addAdjustmentListener(this);
		blueSlider = new Scrollbar(Scrollbar.HORIZONTAL, blueValue, 1, 0, blueValue + 1);
		blueSlider.setBackground(new Color(0, 0, blueValue));
		blueSlider.addAdjustmentListener(this);

		redText = new TextField(""   + redValue, 3);
		redText.addActionListener(this);
		greenText = new TextField(""  + greenValue, 3);
		greenText.addActionListener(this);
		blueText = new TextField("" + blueValue, 3);
		blueText.addActionListener(this);

		redText.setEnabled(false);
		greenText.setEnabled(false);
		blueText.setEnabled(false);
		redText.setVisible(false);
		greenText.setVisible(false);
		blueText.setVisible(false);

		redHex = new TextField("" + Integer.toHexString(redValue), 2);
		redHex.addActionListener(this);
		greenHex = new TextField("" + Integer.toHexString(greenValue), 2);
		greenHex.addActionListener(this);
		blueHex = new TextField("" + Integer.toHexString(blueValue), 2);
		blueHex.addActionListener(this);

		redHex.setEnabled(false);
		greenHex.setEnabled(false);
		blueHex.setEnabled(false);


		gbLayout = new GridBagLayout();
		gbConstraints = new GridBagConstraints();
		gbConstraints.insets = new Insets(2, 2, 2, 2);

		outerBox.setLayout(gbLayout);
		//outerBox.setBackground(Color.white);
		outerBox.setBackground(Color.lightGray); 

		outerBox.setSize(350,200);
		outerBox.setTitle("Selecione uma cor:");

		// set colorBox's constraints
		gbConstraints.anchor = GridBagConstraints.WEST;
		gbConstraints.fill = GridBagConstraints.BOTH;
		gbConstraints.weightx = 3;
		gbConstraints.weighty = 4;
		addMe(outerBox, colorBox, gbLayout, gbConstraints, 0, 0, 1, 3);

		// set Hex values' constraints
		gbConstraints.anchor = GridBagConstraints.CENTER;
		gbConstraints.fill = GridBagConstraints.NONE;
		gbConstraints.weightx = gbConstraints.NONE;
		gbConstraints.weighty = gbConstraints.NONE;
		addMe(outerBox, redHex, gbLayout, gbConstraints, 1, 0, 1, 1);
		addMe(outerBox, greenHex, gbLayout, gbConstraints, 1, 1, 1, 1);
		addMe(outerBox, blueHex, gbLayout, gbConstraints, 1, 2, 1, 1);
/*
		// set Text values' constraints
		gbConstraints.anchor = GridBagConstraints.CENTER;
		gbConstraints.fill = GridBagConstraints.NONE;
		gbConstraints.weightx = gbConstraints.NONE;
		gbConstraints.weighty = gbConstraints.NONE;
		addMe(outerBox, redText, gbLayout, gbConstraints, 2, 0, 1, 1);
		addMe(outerBox, greenText, gbLayout, gbConstraints, 2, 1, 1, 1);
		addMe(outerBox, blueText, gbLayout, gbConstraints, 2, 2, 1, 1);
*/
		// set sliders' constraints
		gbConstraints.anchor = GridBagConstraints.NORTHEAST;
		gbConstraints.fill = GridBagConstraints.HORIZONTAL;
		gbConstraints.weightx = 3;
		gbConstraints.weighty = 3;
		addMe(outerBox, redSlider, gbLayout, gbConstraints, 2, 0, 1, 1); //3
		addMe(outerBox, greenSlider, gbLayout, gbConstraints, 2, 1, 1, 1); //3
		addMe(outerBox, blueSlider, gbLayout, gbConstraints, 2, 2, 1, 1); //3

		//outerBox.addWindowListener(outerBox);

		gbConstraints.weightx = 2;
		gbConstraints.anchor = GridBagConstraints.SOUTHEAST;
		gbConstraints.gridx = 1;
		gbConstraints.gridy = 3;

		BO = makebutton("OK", gbLayout , gbConstraints, outerBox);
		BO.addActionListener(this); 

		gbConstraints.gridx = 2;
		gbConstraints.gridy = 3;

		BC = makebutton("Cancelar", gbLayout , gbConstraints, outerBox);
		BC.addActionListener(this); 

		outerBox.setVisible(true);
		colorBox.setVisible(true);
		colorBox.invalidate();
		outerBox.requestFocus(); 

	}

	private void addMe (Container cup, Component o, GridBagLayout gbL, 
	  GridBagConstraints gbC, int col, int row, int w, int h) {
		gbC.gridx = col;
		gbC.gridy = row;
		gbC.gridwidth = w;
		gbC.gridheight = h;	
		gbL.setConstraints(o, gbC);
		cup.add(o);
	}

	public void actionPerformed (ActionEvent e) {

		if (BO == e.getSource()) {
			outerBox.pack();
			outerBox.dispose();
			OK = true;
			bExit = true;
			result.setText(getColor());
			result.setBackground(new Color (Color.decode(getColor()).getRGB())); 
			return;
		}
		if (BC == e.getSource()) {
			outerBox.pack();
			outerBox.dispose();
			OK = false;
			bExit = true;
			return;
		}


		Object s = e.getSource();

		if (s instanceof TextField) {
			if (s == redText) {
				redValue = Integer.parseInt(redText.getText());
				redSlider.setValue(redValue);
				redHex.setText("" + Integer.toHexString(redValue));
			} else if (s == greenText) {
				greenValue = Integer.parseInt(greenText.getText());
				greenSlider.setValue(greenValue);
				greenHex.setText("" + Integer.toHexString(greenValue));
			} else if (s == blueText) {
				blueValue = Integer.parseInt(blueText.getText());
				blueSlider.setValue(blueValue);
				blueHex.setText("" + Integer.toHexString(blueValue));
			}	
			colorBox.setBackground(new Color(redValue, greenValue, blueValue));
		}
	}

	public void adjustmentValueChanged (AdjustmentEvent e) {
		Object s = e.getSource();

		if (s instanceof Scrollbar) {
			if (s == redSlider) {
				redText.setText("" + redSlider.getValue());
				redHex.setText("" + Integer.toHexString(redSlider.getValue()));
				redValue = redSlider.getValue();
				redSlider.setBackground(new Color(redValue, 0, 0));
			} else if (s == greenSlider) {
				greenText.setText("" + greenSlider.getValue());
				greenHex.setText("" + Integer.toHexString(greenSlider.getValue()));
				greenValue = greenSlider.getValue();
				greenSlider.setBackground(new Color(0, greenValue, 0));
			} else if (s == blueSlider) {
				blueText.setText("" + blueSlider.getValue());
				blueHex.setText("" + Integer.toHexString(blueSlider.getValue()));
				blueValue = blueSlider.getValue();
				blueSlider.setBackground(new Color(0, 0, blueValue));
			}
			colorBox.setBackground(new Color(redValue, greenValue, blueValue));
		}
	}
	public String getColor() {	
		String red, green, blue;

		red = redHex.getText().trim();
		if (red.length()==1) red = red + "0";

		green = greenHex.getText().trim();
		if (green.length()==1) green = green + "0";

		blue = blueHex.getText().trim();
		if (blue.length()==1) blue = blue + "0";


		return("0x"+red + green +  blue);
	}

}
